#!/bin/sh

## this script is supposed to be run one directory below the original configure script
## usually in build-ios

MIN_IOS_VERSION=9.0
IOS_SDK=9.0

LIPO="/Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/bin/lipo"
STRIP="/Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/bin/strip"
LIPO="xcrun -sdk AppleTVOS lipo"
STRIP="xcrun -sdk AppleTVOS strip"

cpus=$(sysctl hw.ncpu | awk '{print $2}')

# remove everything but the static library and this script
#ls | grep -v libjs_static.armv7.a | grep -v libjs_static.armv7s.a | grep -v build.sh | xargs rm -rf

#
# create tvos version (arm64)
#

../configure --with-ios-target=AppleTVOS --with-ios-version=$IOS_SDK --with-ios-min-version=$MIN_IOS_VERSION --with-ios-arch=arm64 \
           --disable-shared-js --disable-tests --disable-ion --disable-jm --disable-tm --enable-llvm-hacks --disable-methodjit --disable-monoic --disable-polyic --disable-yarr-jit \
           --enable-optimize=-O3 --with-thumb=yes --enable-strip --enable-install-strip --without-intl-api --disable-debug --disable-threadsafe \
            --disable-gcgenerational --disable-exact-rooting --enable-fembed-bitcode
make -j$cpus
if (( $? )) ; then
   echo "error when compiling arm64 (iOS version) of the library"
   exit
fi
mv js/src/libjs_static.a js/src/libjs_static.arm64.a

#
# lipo create
#
if [ -e js/src/libjs_static.arm64.a ] ; then
    echo "creating fat version of the library"
    $LIPO -create -output libjs_static.a js/src/libjs_static.arm64.a
    # remove debugging info
    $STRIP -S libjs_static.a
    $LIPO -info libjs_static.a
fi

#
# done
#
echo "*** DONE ***"
echo "If you want to use spidermonkey, copy the 'dist' directory to some accesible place"
echo "e.g. 'cp -pr dist ~/path/to/your/project'"
echo "and then add the proper search paths for headers and libraries in your Xcode project"
